; Dbut du script electricity-logo.scm
;
; Accs par :   Fichier > Crer > Logos > Electricity...
; Et sur image RGBA avec un dessin par :  Filtres > Alpha vers logo > Electricity...
;
; origine : http://www.upstateforums.com/userfiles/gimp2.4scripts/electricity-logo.scm.zip
;
; electricity logo
;
; --------------------------------------------------------------------
; version 1.0 by Michael Schalla 2003/02/17
; version 2.0 by Eric Lamarque 2004/08/20
; version 3.0 ( modifications : register, autocrop, Absolute Size ) by samj (www.aljacom.com/~gimp) 2010/12/01
; version 3.1 ( modification : register ) by samj (www.aljacom.com/~gimp) 2010/12/02
; version 3.2 ( modification by MrQ) update for Gimp-2.10, replace for text: SF-STRING to SF-TEXT 2021/08/25
; version 3.3 ( modification by MrQ) add electricity-logos-animated 2021/08/26, separate script-fu-menu-register to script-fu-register
; --------------------------------------------------------------------
;
; 
(define (script-fu-duplicate-layer-electricity-anim img layer1)

     (let* (

	    (duplicate 0) (position 0)
     )
	

	;undo group
	(gimp-image-undo-group-start img)

	(set! position (car(gimp-image-get-layer-position img layer1)))
	(set! position (+ position 1))

	(set! duplicate (car(gimp-layer-new-from-drawable layer1 img)))
	(gimp-image-add-layer img duplicate -1)

	;end of undo group
	(gimp-image-undo-group-end img)

	;Refresh View
	(gimp-displays-flush)

))

 
(define (scale-layers image drawable
                               new-width 
							   new-height)
		
	(gimp-image-undo-group-start image)	

 (let* (    (layerList (vector->list (cadr (gimp-image-get-layers image))))
			(layerId 0))	
	
	(gimp-context-push)
    (gimp-context-set-interpolation 0)	
	(while (not (null? layerList))
	(set! layerId (car layerList))
	(gimp-layer-scale layerId new-width new-height 0)
	(gimp-layer-resize (car (gimp-image-get-active-layer image)) new-width new-height 0 0)
	(set! layerList (cdr layerList)))	
	(gimp-image-resize-to-layers image)
	(gimp-displays-flush)
	(gimp-image-undo-group-end image)
	(gimp-context-pop)
 )
)

(define (apply-electricity-logo-effect img inLayer inGrow inElectricity inColor autocrop)
	(let*
		(
			(width (car (gimp-drawable-width inLayer)))
			(height (car (gimp-drawable-height inLayer)))
			;(theElectricityLayer (car (gimp-layer-new img width height RGBA-IMAGE "Electricity" 100 ADDITION)))  LAYER-MODE-ADDITION-LEGACY
			(theElectricityLayer (car (gimp-layer-new img width height RGBA-IMAGE "Electricity" 100 LAYER-MODE-ADDITION-LEGACY))) ; MrQ
			(old-fg (car (gimp-palette-get-foreground)))
			(old-bg (car (gimp-palette-get-background)))
		)

		(gimp-image-resize img width height 0 0)
		(gimp-image-add-layer img theElectricityLayer 0)
		(gimp-edit-clear theElectricityLayer)
		(gimp-selection-layer-alpha inLayer)

		(if 
			(> inGrow 0)
			
				(gimp-selection-grow img inGrow)

					(if 
						(< inGrow 0)
						
							(gimp-selection-shrink img (- 0 inGrow))
					)
		)

		(gimp-palette-set-foreground '(255 255 255))
		;(gimp-edit-fill theElectricityLayer FG-IMAGE-FILL)
		(gimp-edit-fill theElectricityLayer FILL-FOREGROUND) ; MrQ
		(gimp-selection-none img)

		(plug-in-cubism 1 img theElectricityLayer inElectricity 2.5 0)
		(plug-in-ripple 1 img theElectricityLayer inElectricity (/ inElectricity 4) 1 0 1 TRUE FALSE)
		(plug-in-ripple 1 img theElectricityLayer inElectricity (/ inElectricity 2) 0 0 1 TRUE FALSE)
		(plug-in-ripple 1 img theElectricityLayer inElectricity (/ inElectricity 4) 1 0 1 TRUE FALSE)

		(plug-in-spread 1 img theElectricityLayer inElectricity inElectricity)
		(plug-in-gauss-iir 1 img theElectricityLayer 3 TRUE TRUE)

		(define (set-pt a index x y)
		
			(begin
			
				(aset a (* index 2) x)
				(aset a (+ (* index 2) 1) y)
				
			)
		)

		(define (splineValue)

		(let* 
			(
				(a (cons-array 15 'byte))
			)
			
			(set-pt a 0 0 0)
			(set-pt a 1 32 64)
			(set-pt a 2 96 255)
			(set-pt a 3 160 64)
			(set-pt a 4 255 0)
			a
		)
	)

	;(gimp-curves-spline theElectricityLayer VALUE-LUT 10 (splineValue))
	(gimp-curves-spline theElectricityLayer HISTOGRAM-VALUE 10 (splineValue)) ;MrQ
	;(define red (larg-default inColor 0 0))
	(define red (nth 0 inColor))
	
	(if 
		(= red 0)
		
			(set! red 1)
			
			(if 
				(= red 255)
					
					(set! red 254)
			)
	)

	;(define green (larg-default inColor 1 0))
	(define green (nth 1 inColor))
	
	(if 
		(= green 0)
		
			(set! green 1)
			
			(if 
				(= green 255)
			
					(set! green 254)
			)
	)

	;(define blue (larg-default inColor 2 0))
	(define blue (nth 2 inColor))
	
	(if 
		(= blue 0)
		
			(set! blue 1)
			
			(if 
				(= blue 255)
					
					(set! blue 254)
			)
	)

	(define gray (/ (+ (* red 299) (* green 587) (* blue 114)) 1000))

	(define (splineRed)
		(let* 
			(
				(a (cons-array 6 'byte))
			)
		(set-pt a 0 0 0)
		(set-pt a 1 gray red)
		(set-pt a 2 255 255)
		a
		)
	)

	;(gimp-curves-spline theElectricityLayer RED-LUT 6 (splineRed)) 
	(gimp-curves-spline theElectricityLayer HISTOGRAM-RED 6 (splineRed)) ; MrQ
	(define (splineGreen)
		(let* 
			(
				(a (cons-array 6 'byte))
			)
		(set-pt a 0 0 0)
		(set-pt a 1 gray green)
		(set-pt a 2 255 255)
		a
		)
	)

	;(gimp-curves-spline theElectricityLayer GREEN-LUT 6 (splineGreen)) 
	(gimp-curves-spline theElectricityLayer HISTOGRAM-GREEN 6 (splineGreen)) ; MrQ
	(define (splineBlue)
		(let* 
			(
			(a (cons-array 6 'byte))
		)
		(set-pt a 0 0 0)
		(set-pt a 1 gray blue)
		(set-pt a 2 255 255)
		a
		)
	)

	;(gimp-curves-spline theElectricityLayer BLUE-LUT 6 (splineBlue))
	(gimp-curves-spline theElectricityLayer HISTOGRAM-BLUE 6 (splineBlue)) ; MrQ
	;(gimp-curves-spline theElectricityLayer ALPHA-LUT 10 (splineValue))
	(gimp-curves-spline theElectricityLayer HISTOGRAM-ALPHA 10 (splineValue)) ; MrQ	
		; ajout samj
		(if 
			(= autocrop TRUE) 
				(plug-in-autocrop 1 img theElectricityLayer)
		)

	(gimp-palette-set-background old-bg)
	(gimp-palette-set-foreground old-fg)
	)
)


(define (script-fu-electricity-alpha-mrq img theLayer inGrow inElectricity inIceColor)
	(begin
		(gimp-undo-push-group-start img)
		
		; modif samj
		;(apply-electricity-logo-effect img theLayer inGrow inElectricity inIceColor)
		(apply-electricity-logo-effect img theLayer inGrow inElectricity inIceColor 0)
				
		(gimp-undo-push-group-end img)
		(gimp-displays-flush)
	)
)

(script-fu-register "script-fu-electricity-alpha-mrq"
	;_"<Image>/Script-Fu/Electricity..."
	_"Electricity..."
	"Creates a electricity logo."
	"Michael Schalla/MrQ"
	"Michael Schalla"
	"Februar 2001/2021"
	"RGBA"
	SF-IMAGE "Image" 0
	SF-DRAWABLE "Drawable" 0
	SF-ADJUSTMENT "Grow" '(-6 -50 50 1 1 0 1)
	SF-ADJUSTMENT "Electricity" '(16 2 100 1 1 0 1)
	SF-COLOR "Electricity Color" '(32 128 255)
)
(script-fu-menu-register "script-fu-electricity-alpha-mrq" "<Image>/Filters/Alpha to Logo")

(define (script-fu-electricity-logo-mrq inText inFont inFontSize inIceColor inTextColor inGrow inElectricity inAbsolute inImageWidth inImageHeight inFlatten autocrop)
	(let*
		(
			(img ( car (gimp-image-new 10 10 RGB)))
			(theText)
			(theTextWidth)
			(theTextHeight)
			(imgWidth)
			(imgHeight)
			(theBufferX)
			(theBufferY)
			(theTextLayer2)

			;(theLayer (car (gimp-layer-new img 10 10 RGB-IMAGE "Ebene 1" 100 NORMAL)))
			;(theTextLayer (car (gimp-layer-new img 10 10 RGBA-IMAGE "Ebene 2" 100 NORMAL)))
			(theLayer (car (gimp-layer-new img 10 10 RGB-IMAGE "Ebene 1" 100 LAYER-MODE-NORMAL-LEGACY))) ; MrQ
			(theTextLayer (car (gimp-layer-new img 10 10 RGBA-IMAGE "Ebene 2" 100 LAYER-MODE-NORMAL-LEGACY))) ; MrQ
			(old-fg (car (gimp-palette-get-foreground) ) )
			(old-bg (car (gimp-palette-get-background) ) )
		)

	(gimp-image-add-layer img theLayer 0)
	(gimp-image-add-layer img theTextLayer 0)
	; (gimp-display-new img)

	(gimp-palette-set-background '(0 0 0) )
	(gimp-palette-set-foreground inTextColor)

	(gimp-selection-all img)
	(gimp-edit-clear theLayer)
	(gimp-edit-clear theTextLayer)
	(gimp-selection-none img)

	(set! theText (car (gimp-text-fontname img theTextLayer 0 0 inText 0 TRUE inFontSize PIXELS inFont)))
	(set! theTextWidth (car (gimp-drawable-width theText)))
	(set! theTextHeight (car (gimp-drawable-height theText)))

	(set! imgWidth inImageWidth )
	(set! imgHeight inImageHeight )

	; modif samj
	;(if 
		;(= inAbsolute FALSE)
			(set! imgWidth (+ theTextWidth theTextHeight inElectricity ) )
	;)

	;modif samj
	;(if 
		;(= inAbsolute FALSE)
			(set! imgHeight (+ (* theTextHeight 1.5 ) (* (+ inElectricity inGrow ))))
	;)

	(set! theBufferX (/ (- imgWidth theTextWidth) 2) )
	(set! theBufferY (+ (/ (- imgHeight theTextHeight) 2) (+ inElectricity inGrow )))

	(gimp-image-resize img imgWidth imgHeight 0 0)
	(gimp-layer-resize theLayer imgWidth imgHeight 0 0)
	(gimp-layer-resize theTextLayer imgWidth imgHeight 0 0)

	(gimp-layer-set-offsets theText theBufferX theBufferY )
	;(gimp-floating-sel-anchor theText theTextLayer)
	(gimp-floating-sel-anchor theText)

	(set! theTextLayer2 (car (gimp-layer-copy theTextLayer TRUE)))
	(gimp-image-add-layer img theTextLayer2 1)

	(plug-in-gauss-iir 1 img theTextLayer2 16 TRUE TRUE)
	(plug-in-bump-map 1 img theTextLayer theTextLayer2 135.0 45.0 32 0 0 0 0 TRUE FALSE 0)

	(gimp-selection-layer-alpha theTextLayer)
	(gimp-selection-grow img 2)
	(gimp-selection-feather img 8)


	(gimp-palette-set-foreground '(255 255 255))
	;(gimp-edit-fill theTextLayer2 FG-IMAGE-FILL)
	(gimp-edit-fill theTextLayer2 FILL-FOREGROUND) ; MrQ
	(gimp-selection-none img)

	(apply-electricity-logo-effect img theTextLayer inGrow inElectricity inIceColor autocrop)
	
	(if 
		(= inFlatten TRUE)
			(gimp-image-flatten img)
		; else	
			()	
	)

	; modif samj
	(if 
		(= inAbsolute TRUE)
			(begin
				; aplatir et redimensionner image
				(gimp-image-flatten img)
				(gimp-image-resize img inImageWidth inImageHeight 0 0)
				(gimp-layer-scale-full (car (gimp-image-get-active-layer img)) inImageWidth inImageHeight FALSE 2)
				(gimp-layer-resize (car (gimp-image-get-active-layer img)) inImageWidth inImageHeight 0 0)					
			)
	)	
	
	
	(gimp-palette-set-background old-bg)
	(gimp-palette-set-foreground old-fg)

	(gimp-display-new img)
	(list img theLayer theText)

	)
)

(script-fu-register
	"script-fu-electricity-logo-mrq"
	;"<Toolbox>/Xtns/Script-Fu/Logos/Electricity..."
	"Electricity..."
	"Creates a electricity logo."
	"Michael Schalla/MrQ"
	"Michael Schalla"
	"October 2002/2021"
	""
	;SF-STRING "Text" "Gimp 2.6"
	SF-TEXT "Text" "Gimp 2.10" ; MrQ
	SF-FONT "Font" "Arial Black"
	SF-ADJUSTMENT "Font Size" '(160 2 1000 1 10 0 1)
	SF-COLOR "Electricity Color" '(32 128 255)
	SF-COLOR "Text Color" '(192 64 64)
	SF-ADJUSTMENT "Grow" '(-6 -50 50 1 1 0 1)
	SF-ADJUSTMENT "Electricity" '(16 2 100 1 1 0 1)
	SF-TOGGLE "Absolute Size and Flatten" FALSE
	SF-VALUE "Image Width" "400"
	SF-VALUE "Image Height" "150"
	SF-TOGGLE "Flatten Layers?" FALSE
	SF-TOGGLE "Autocrop logo" TRUE
)

(script-fu-menu-register "script-fu-electricity-logo-mrq" "<Image>/File/Create/Logos")
; FIN du script
;from the original script
(define (apply-electricity-logo-effects-mrq img inLayer inGrow inElectricity inColor)
     (let*
          (
               (width (car (gimp-drawable-width inLayer)))
               (height (car (gimp-drawable-height inLayer)))

               ;(theElectricityLayer (car (gimp-layer-new img width height RGBA-IMAGE "Electricity" 100 ADDITION)))
               (theElectricityLayer (car (gimp-layer-new img width height RGBA-IMAGE "Electricity" 100 LAYER-MODE-ADDITION-LEGACY)))
               (old-fg (car (gimp-palette-get-foreground)))
               (old-bg (car (gimp-palette-get-background)))
               (splineValue (cons-array 10 'byte))
               (splineArr (cons-array 6 'byte))
               (red (min 254 (max 1 (car inColor))))
               (green (min 254 (max 1 (cadr inColor))))
               (blue (min 254 (max 1 (caddr inColor))))
               (gray (/ (+ (* red 299) (* green 587) (* blue 114)) 1000))
          )
     
          (gimp-image-resize img width height 0 0)
          (gimp-image-add-layer img theElectricityLayer 0)
          (gimp-edit-clear theElectricityLayer)

          (gimp-selection-layer-alpha inLayer)

          (if (> inGrow 0)
               (gimp-selection-grow img inGrow)
               (if (< inGrow 0)
                    (gimp-selection-shrink img (- 0 inGrow))
               )     
          )
               
          (gimp-palette-set-foreground '(255 255 255))
          ;gimp-edit-fill theElectricityLayer FG-IMAGE-FILL)
          (gimp-edit-fill theElectricityLayer FILL-FOREGROUND)		  
          (gimp-selection-none img)

          (plug-in-cubism 1 img theElectricityLayer inElectricity 2.5 0)
          (plug-in-ripple 1 img theElectricityLayer inElectricity (/ inElectricity 4) 1 0 1 TRUE FALSE)
          (plug-in-ripple 1 img theElectricityLayer inElectricity (/ inElectricity 2) 0 0 1 TRUE FALSE)
          (plug-in-ripple 1 img theElectricityLayer inElectricity (/ inElectricity 4) 1 0 1 TRUE FALSE)
          (plug-in-spread 1 img theElectricityLayer inElectricity inElectricity)

          (plug-in-gauss-iir 1 img theElectricityLayer 3 TRUE TRUE)

          ;; splineValue = #( 0 0 32 64 96 255 160 64 255 0 )
          (aset splineValue 2 32)
          (aset splineValue 3 64)
          (aset splineValue 4 96)
          (aset splineValue 5 255)
          (aset splineValue 6 160)
          (aset splineValue 7 64)
          (aset splineValue 8 255)
          ;(gimp-curves-spline theElectricityLayer VALUE-LUT 10 splineValue)
          (gimp-curves-spline theElectricityLayer HISTOGRAM-VALUE 10 splineValue)
          ;; splineRed = #( 0 0 gray red 255 255)
          (aset splineArr 2 gray)
          (aset splineArr 3 red)
          (aset splineArr 4 255)
          (aset splineArr 5 255)
          ;(gimp-curves-spline theElectricityLayer RED-LUT 6 splineArr)
          (gimp-curves-spline theElectricityLayer HISTOGRAM-RED 6 splineArr)
          ;; splineGreen = #( 0 0 gray green 255 255)
          (aset splineArr 3 green)
          ;(gimp-curves-spline theElectricityLayer GREEN-LUT 6 splineArr)
          (gimp-curves-spline theElectricityLayer HISTOGRAM-GREEN 6 splineArr)
          ;; splineBlue = #( 0 0 gray blue 255 255)
          (aset splineArr 3 blue)
          ;(gimp-curves-spline theElectricityLayer BLUE-LUT 6 splineArr)
          (gimp-curves-spline theElectricityLayer HISTOGRAM-BLUE 6 splineArr)
          ;(gimp-curves-spline theElectricityLayer ALPHA-LUT 10 splineValue)
          (gimp-curves-spline theElectricityLayer HISTOGRAM-ALPHA 10 splineValue)
          (gimp-palette-set-background old-bg)
          (gimp-palette-set-foreground old-fg)
     )
)



;modified source to add the animation option

(define (script-fu-electricity-logos-animated-mrq framenum inText inFont inFontSize inIceColor inTextColor inGrow inElectricity inAbsolute inImageWidth inImageHeight inFlatten)
  (let*
    (
      ; Definition unserer lokalen Variablen

      ; Erzeugen des neuen Bildes

      (img  ( car (gimp-image-new 10 10 RGB) ) )
      (theText)
      (theTextWidth)
      (theTextHeight)
      (imgWidth)
      (imgHeight)
      (theBufferX)
      (theBufferY)
      (theTextLayer2)
      (animation)
      (duplicate)
	  (x)
      (framenum_source framenum)
	

      ; Erzeugen einer neuen Ebene zum Bild
      ;(theLayer (car (gimp-layer-new img 10 10 RGB-IMAGE "Ebene 1" 100 NORMAL) ) )LAYER-MODE-NORMAL-LEGACY
      (theLayer (car (gimp-layer-new img 10 10 RGB-IMAGE "Ebene 1" 100 LAYER-MODE-NORMAL-LEGACY) ) )	  
      ;(theTextLayer (car (gimp-layer-new img 10 10 RGBA-IMAGE "Ebene 2" 100 NORMAL) ) )
      (theTextLayer (car (gimp-layer-new img 10 10 RGBA-IMAGE "Ebene 2" 100 LAYER-MODE-NORMAL-LEGACY) ) )
      (old-fg (car (gimp-palette-get-foreground) ) )
      (old-bg (car (gimp-palette-get-background) ) )
      ; Ende unserer lokalen Variablen
    )

    (gimp-image-add-layer  img theLayer 0)
    (gimp-image-add-layer  img theTextLayer 0)

    ; zum Anzeigen des leeren Bildes
    ; (gimp-display-new img)

    (gimp-palette-set-background '(0 0 0) )
    (gimp-palette-set-foreground inTextColor)

    (gimp-selection-all  img)
    (gimp-edit-clear     theLayer)
    (gimp-edit-clear     theTextLayer)
    (gimp-selection-none img)

    (set! theText (car (gimp-text-fontname img theTextLayer 0 0 inText 0 TRUE inFontSize PIXELS inFont)))

    (set! theTextWidth  (car (gimp-drawable-width  theText) ) )
    (set! theTextHeight (car (gimp-drawable-height theText) ) )

    (set! imgWidth inImageWidth )
    (set! imgHeight inImageHeight )

    ;(if (= inAbsolute FALSE)
      (set! imgWidth (+ theTextWidth theTextHeight inElectricity ) )
    ;)

    ;(if (= inAbsolute FALSE)
      (set! imgHeight (+ (* theTextHeight 1.5 ) (*  (+ inElectricity inGrow ) ) ) )
    ;)

    (set! theBufferX      (/ (- imgWidth theTextWidth) 2) )
    (set! theBufferY      (+ (/ (- imgHeight theTextHeight) 2) (+ inElectricity inGrow ) ) )

    (gimp-image-resize img imgWidth imgHeight 0 0)
    (gimp-layer-resize theLayer imgWidth imgHeight 0 0)
    (gimp-layer-resize theTextLayer imgWidth imgHeight 0 0)

    (gimp-layer-set-offsets  theText theBufferX theBufferY )
	
    (gimp-floating-sel-anchor theText)

    (set! theTextLayer2 (car (gimp-layer-copy theTextLayer TRUE)))
    (gimp-image-add-layer img theTextLayer2 1)

    (plug-in-gauss-iir 1 img theTextLayer2 16 TRUE TRUE)
    (plug-in-bump-map 1 img theTextLayer theTextLayer2 135.0 45.0 32 0 0 0 0 TRUE FALSE 0)

    (gimp-selection-layer-alpha theTextLayer)

    (gimp-selection-grow img 2)
    (gimp-selection-feather img 8)
		
		(gimp-palette-set-foreground '(255 255 255))
		;(gimp-edit-fill theTextLayer2 FG-IMAGE-FILL)
		(gimp-edit-fill theTextLayer2 FILL-FOREGROUND)		
		(gimp-selection-none img)

		(script-fu-duplicate-layer-electricity-anim img theTextLayer)
		(set! duplicate (car(gimp-image-get-active-layer img)))
		(gimp-drawable-set-visible duplicate FALSE)

		(gimp-edit-copy-visible img)
				
		(apply-electricity-logo-effects-mrq img duplicate inGrow inElectricity inIceColor)

		(if (not (= framenum 1))
 		(gimp-image-merge-visible-layers img 0) () )

		(while (> (- framenum 1) 0)
		(begin
			(set! animation (car(gimp-edit-paste duplicate TRUE)))
			(set! animation (car(gimp-floating-sel-to-layer animation)))
			(apply-electricity-logo-effects-mrq img duplicate inGrow inElectricity inIceColor)
			(set! animation (car(gimp-image-get-active-layer img)))
			(gimp-image-lower-item-to-bottom img duplicate)
						(set! x (car(gimp-image-merge-down img animation 0)))
			(gimp-image-lower-item-to-bottom img x)
			(set! framenum (- framenum 1))

						;(gimp-image-lower-item-to-bottom img animation)
		) )
				(if(= inAbsolute TRUE)
				(gimp-layer-scale-full x inImageWidth inImageHeight FALSE 2))
		(gimp-image-remove-layer img duplicate)
				
	(if (= framenum_source 1)
	(begin
		(if (= inFlatten TRUE)
      		(gimp-image-flatten img) ()  )	
	) )
			
    (gimp-palette-set-background old-bg)
    (gimp-palette-set-foreground old-fg)
	(if(= inAbsolute TRUE)


	(scale-layers img animation inImageWidth inImageHeight))
    (gimp-display-new img)
    (list  img theLayer theText)

    ; Bereinigen Dirty-Flag
    ;(gimp-image-clean-all img)

  )
)

(script-fu-register
  "script-fu-electricity-logos-animated-mrq"
  "Electricity Logo animated"
  "Creates an animated electricity logo based on the electricity logo script."
  "Michael Schalla/MrQ"
  "Michael Schalla"
  "2002/2021"
  ""
  SF-ADJUSTMENT "How Many Frames? \n(Use this to make an Animation)"      '(5 1 50 1 10 0 1)
  SF-TEXT "Text"               "Electricity"
  SF-FONT   "Font"               "Arial Bold"
  SF-ADJUSTMENT "Font Size"      '(200 2 1000 1 10 0 1)
  SF-COLOR  "Electricity Color"  '(32 128 255)
  SF-COLOR  "Text Color"         '(192 64 64)
  SF-ADJUSTMENT "Grow"					 '(-6 -50 50 1 1 0 1)
  SF-ADJUSTMENT "Electricity" 	 '(16 2 100 1 1 0 1)
  SF-TOGGLE "Absolute Size?"     FALSE
  SF-VALUE  "Image Width"        "400"
  SF-VALUE  "Image Height"       "150"
  SF-TOGGLE "Flatten Image? \n(Only used when there is 1 Frame)"     FALSE
)
(script-fu-menu-register "script-fu-electricity-logos-animated-mrq" "<Image>/Filters/Animation/Animators")